#!/bin/bash

# Get path of BayesWaveBurst to figure out where the postprocessing scripts are
pathtoBWB=$(which BayesWaveBurst)

if [ -s "$pathtoBWB" ] ; then
    pathtoBWB=${pathtoBWB%src*}
    fulldirname="$(pwd)"
    for dirname in $fulldirname/job*; do
        echo
        echo "Entering $dirname ..."
        cd $dirname
        MDC="$(grep MDC *bayeswave.run)"
        if [ ${#MDC} -ne "0" ]
        then
            echo
            echo " * Running plot_waveform..."
            python -W ignore $pathtoBWB/postprocess/plot_waveform.py --mdc=True
            #python -W ignore /home/francesco.pannarale/scripts/BayesWaveTools/plot_waveform.py --mdc=True
            echo
            echo " * Running plot_evidence..."
            
        else
            echo
            echo " * Running plot_waveform..."
            python -W ignore $pathtoBWB/postprocess/plot_waveform.py --mdc=False
            #python -W ignore /home/francesco.pannarale/scripts/BayesWaveTools/plot_waveform.py --mdc=False
        fi
        echo
        echo " * Running skymap..."
        $pathtoBWB/postprocess/run_skymap.sh
        echo
        echo " * Compressing analyzed data..."
        tar -cf waveforms.tar waveforms
        tar -cf chains.tar chains
        tar -cf snr.tar *snr
        cd ..
        echo
        echo " * ...DONE!"
        echo
    done
    echo
    echo
    echo "To move the postprocessing results in order to make them visible. Run:"
    echo "  rsync -av --progress <path to this directory> <path to the desired directory in the public_html>  --exclude '*/*snr' --exclude '*/waveforms' --exclude '*/chains' --exclude '*/post' --include='*/' --include '*html' --include '*png' --include condorOut_BWB.txt --exclude='*'"
    echo
    echo
else
    echo "Make sure the BayesWaveBurst command is in your path before running this script!"
fi
