
import glob
import os
import readbwb

# -- Parameters
# mdclog = '/home/jkanner/baysewave/svn/trunk/burstinj/s6/BurstMDC-BRST_S6-Log.txt'
mdclog = '/home/jkanner/baysewave/svn/trunk/burstinj/s6/BurstMDC-ELPTC_S6-Log.txt'
runfile = open('run_pp.sh', 'w')
dirlist = glob.glob('*/job*')
dirlist = [os.path.abspath(directory) for directory in dirlist]
print dirlist

for directory in dirlist:
    os.chdir(directory)
    print directory

    # -- Get scale factor and gps
    param = readbwb.BwbParams()
    scale = param.scale
    gps   = param.gps

    # -- Write out submit file and doit file here
    doitfile = open('pp.sh', 'w')
    doitfile.write("""#! /bin/sh
cd {directory}
source /home/jkanner/.bashrc.mine

# /home/jkanner/baysewave/svn/trunk/src/BayesWavePostPEC --ifo H1 --H1-flow 16 --H1-cache LALAdLIGO --H1-channel LALAdLIGO --ifo L1 --L1-flow 16 --L1-cache LALAdLIGO --L1-channel LALAdLIGO --trigtime {gps} --srate 1024 --seglen 4 --PSDstart {gps} --PSDlength 4 --dataseed 1234 --0noise  --MDC-channel [H1:GW-H,L1:GW-H] --MDC-cache [/home/jkanner/baysewave/svn/trunk/burstinj/s6/brst_s6.cache,/home/jkanner/baysewave/svn/trunk/burstinj/s6/brst_s6.cache] --MDC-prefactor {scale}   --bayesLine 

python /home/jkanner/baysewave/svn/trunk/postprocess/s6/run_bwpPEC.py
python /home/jkanner/baysewave/svn/trunk/postprocess/s6/plot_pec.py
python /home/jkanner/baysewave/svn/trunk/postprocess/skymap/skyview.py --mdc {mdclog}

""".format(directory=directory, scale=scale, gps=gps, mdclog=mdclog))
    doitfile.close()
    
    submitfile = open('submitpp.txt','w')
    submitfile.write("""
executable={top}/pp.sh
universe=vanilla
arguments=""
output={top}/ppOut.txt
error={top}/ppError.txt
log={top}/ppLog.txt
notification=never
should_transfer_files=YES
when_to_transfer_output = ON_EXIT
stream_error=True
stream_output=True
RequestMemory = 2000
queue 1
""".format(top=directory))
    submitfile.close()
                    
    # -- Write line to runfile to cd to this directory and submit this job
    runfile.write("cd {0}\n".format(directory))
    runfile.write("condor_submit {0}\n\n".format( os.path.join(directory, 'submitpp.txt') ))

runfile.close()
print "Thank you, come again."
