
import glob
import os

# -- Parameters
# mdclog = '/home/jkanner/baysewave/svn/trunk/burstinj/s6/BurstMDC-BRST_S6-Log.txt'
mdclog = '/home/jkanner/baysewave/svn/trunk/burstinj/s6/BurstMDC-ELPTC_S6-Log.txt'
runfile = open('run_pp.sh', 'w')
dirlist = glob.glob('*/job*')
dirlist = [os.path.abspath(directory) for directory in dirlist]
print dirlist

for directory in dirlist:
    os.chdir(directory)

    # -- Write out submit file and doit file here
    doitfile = open('pp.sh', 'w')
    doitfile.write("""#! /bin/sh
cd {directory}
source /home/jkanner/.bashrc.mine
python /home/jkanner/baysewave/svn/trunk/postprocess/skymap/skyview.py --mdc {mdclog}
""".format(directory=directory, mdclog=mdclog))
    doitfile.close()
    
    submitfile = open('submitpp.txt','w')
    submitfile.write("""
executable={top}/pp.sh
universe=vanilla
arguments=""
output={top}/ppOut.txt
error={top}/ppError.txt
log={top}/ppLog.txt
notification=never
should_transfer_files=YES
when_to_transfer_output = ON_EXIT
stream_error=True
stream_output=True
queue 1
""".format(top=directory))
    submitfile.close()
                    
    # -- Write line to runfile to cd to this directory and submit this job
    runfile.write("cd {0}\n".format(directory))
    runfile.write("condor_submit {0}\n\n".format( os.path.join(directory, 'submitpp.txt') ))

runfile.close()
print "Thank you, come again."
