import readbwb
from subprocess import call
import os

# -- Get options
params = readbwb.BwbParams()

cmd = ''
flow = params.flowList[0]

for ifo in params.ifoNames:

    cmd += " --ifo {0}".format(ifo)
    cmd += " --{0}-flow {1}".format(ifo, flow)
    cmd += " --{0}-cache LALAdLIGO".format(ifo)
    cmd += " --{0}-channel LALAdLIGO".format(ifo)
    
cmd += " --trigtime {0}".format(params.gps)
cmd += " --srate {0}".format(params.srate)
cmd += " --seglen {0}".format(params.seglen)
cmd += " --PSDstart {0}".format(params.gps)
cmd += " --PSDlength {0}".format(params.seglen)
cmd += " --dataseed 1234 --0noise"

if params.bayesline:
    cmd += " --bayesLine"

try:
    cmd += " --MDC-channel {0}".format(params.mdc_channel)
    cmd += " --MDC-cache {0}".format(params.mdc_cache)
    cmd += " --MDC-prefactor {0}".format(params.scale)
except:
    pass

try: 
    print "Trying to print params.xml"
    print params.xml
    cmd += " --inj {0}".format(params.xml)
    cmd += " --event {0}".format(params.event)
except:
    pass


print ""
print cmd


# -- Create soft links if needed
os.chdir('chains')
try:
    print "Trying to make soft links"
    call( 'ln -s signal_1_extchain.dat.0 signal_extchain.dat.0', shell=True) 
    call( 'ln -s signal_1_intchain.dat.0 signal_intchain.dat.0', shell=True) 
    call( 'ln -s signal_1_wavechain.dat.0 signal_wavechain.dat.0', shell=True) 
except:
    print "Failed to link signal model"
    pass

try:
    call( 'ln -s glitch_1_glitchchain_ifo0.dat.0 glitch_glitchchain_ifo0.dat.0', shell=True)
    call( 'ln -s glitch_1_glitchchain_ifo1.dat.0 glitch_glitchchain_ifo1.dat.0', shell=True)
    call( 'ln -s glitch_1_intchain.dat.0  glitch_intchain.dat.0'  , shell=True)
except:
    print "Failed to link glitch model"
    pass

os.chdir('..')

print cmd
call('/home/meg.millhouse/bayeswave/trunk/src/BayesWavePost ' + cmd, shell=True)
