/* ********************************************************************************** */
/*                                                                                    */
/*                            Wavelet basis functions                                 */
/*                                                                                    */
/* ********************************************************************************** */

double SineGaussianSNR(double *params, double *Snf, double Tobs);
void SineGaussianBandwidth(double *sigpar, double *fmin, double *fmax);
void SineGaussianFourier(double *hs, double *sigpar, int N, int flag, double Tobs);
void SineGaussianFisher(double *params, struct FisherMatrix *fisher);

/* ********************************************************************************** */
/*                                                                                    */
/*                         Network projection functions                               */
/*                                                                                    */
/* ********************************************************************************** */

void computeProjectionCoeffs(struct Data *data, struct Network *projection, double *extParams, double fmin, double fmax);
void waveformProject(struct Data *data, struct Network *projection, double *extParams, double **response, double *geo, double fmin, double fmax);
void compute_reconstructed_plus_and_cross(struct Data *data, struct Network *projection, double *extParams, double **hrecPlus, double **hrecCross, double *geo, double fmin, double fmax);
